const app = getApp()
import WxValidate from '../../utils/wxValidate'
import { is_show_project } from '../../utils/dict';
const moment = require("../../utils/moment.min")

Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '信息管理', leftArrow: true, useBar: false },
        id: '',
        // 是否使用
        is_showList: is_show_project,
        form: {},
    },
    initValidate() {
        const rules = { title: { required: true }, create_time: { required: false }, origin: { required: true }, brief: { required: true }, content: { required: false }, is_show: { required: true } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { title: { required: '请输入话题名称', }, create_time: { required: '请输入发布时间', }, origin: { required: '请输入信息来源', }, brief: { required: '请输入信息简介' }, content: { required: '请输入信息内容' }, is_show: { required: '请选择是否公开' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    // 返回
    back: function () {
        wx.navigateBack({ delta: 1 })
    },
    //用户输入内容
    inputChange: function (e) {
        const that = this;
        let html = e.detail.html;
        that.setData({ "form.content": html });
    },
    // 是否公开
    is_showChange: function (e) {
        const that = this;
        let index = e.detail.value;
        let value = that.data.is_showList[index];
        that.setData({ 'form.is_show': value.value });
    },

    // 提交登录
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        const data = that.data.form;
        params.content = data.content;
        params.create_time = moment().format('YYYY-MM-DD');
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            let arr;
            if (data._id) {
                arr = await app.$post(`/newCourt/api/topic/${data._id}`, params);
            }
            else {
                arr = await app.$post(`/newCourt/api/topic`, params);
            }
            if (arr.errcode == '0') { wx.showToast({ title: `维护信息完成`, icon: 'success', duration: 2000 }); that.back(); }
            else wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
        }
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        that.setData({ id: options.id || '' })
        //验证规则函数
        that.initValidate();
        // 监听用户是否登录
        that.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                if (that.data.id) {
                    const arr = await app.$get(`/newCourt/api/topic/${that.data.id}`);
                    if (arr.errcode == '0') {
                        that.setData({ form: arr.data });
                    }
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})